Engineering Papers⌕ Search

SEARCH · Engineering Papers

Results for “matrix algebra”

Search indexed NASA NTRS and DOE OSTI research on propulsion, heat transfer, battery materials and energy systems. Follow report and document links to the original sources.

Quote a phrase for an exact phrase match. Source license links do not imply unrestricted reuse.

At least 361 records · Page 20

Extended Lagrangian Born–Oppenheimer molecular dynamics using a Krylov subspace approximation

It is shown how the electronic equations of motion in extended Lagrangian Born–Oppenheimer molecular dynamics simulations can be integrated using low-rank approximations of the inverse Jacobian kernel. This kernel determines the metric tensor in the harmonic oscillator extension of the Lagrangian that drives the evolution of the electronic degrees of freedom. The proposed kernel approximation is derived from a pseudoinverse of a low-rank estimate of the Jacobian, which is expressed in terms of a generalized set of directional derivatives with directions that are given from a Krylov subspace approximation. The approach allows a tunable and adaptive approximation that can take advantage of efficient preconditioning techniques. The proposed kernel approximation for the integration of the electronic equations of motion makes it possible to apply extended Lagrangian first-principles molecular dynamics simulations to a broader range of problems, including reactive chemical systems with numerically sensitive and unsteady charge solutions. This can be achieved without requiring exact full calculations of the inverse Jacobian kernel in each time step or relying on iterative non-linear self-consistent field optimization of the electronic ground state prior to the force evaluations as in regular direct Born–Oppenheimer molecular dynamics. We note the low-rank approximation of the Jacobian is directly related to Broyden’s class of quasi-Newton algorithms and Jacobian-free Newton–Krylov methods and provides a complementary formulation for the solution of nonlinear systems of equations.

71 CLASSICAL AND QUANTUM MECHANICS, GENERAL PHYSIC↗

Microstate distinguishability, quantum complexity, and the eigenstate thermalization hypothesis

In this work, we use quantum complexity theory to quantify the difficulty of distinguishing eigenstates obeying the eigenstate thermalization hypothesis (ETH). After identifying simple operators with an algebra of low-energy observables and tracing out the complementary high-energy Hilbert space, the ETH leads to an exponential suppression of trace distance between the coarse grained eigenstates. Conversely, we show that an exponential hardness of distinguishing between states implies ETH-like matrix elements. Finally, the BBBV lower bound on the query complexity of Grover search then translates directly into a complexity-theoretic statement lower bounding the hardness of distinguishing these reduced states

71 CLASSICAL AND QUANTUM MECHANICS, GENERAL PHYSIC↗

Efficient Integration of Algebraic Constraint for Exponential Time Integration

This work is a continuation of a previous project where the high efficiency of exponential integration methods for DRMHD systems was demonstrated. Often algebraic constraints must also be enforced for DRMHD systems of interest. Straightforward application of exponential methods to DRMHD equations with constraints leads to prohibitively computationally expensive methods. In this work, we propose new exponential schemes that allow the constraints to be removed from evaluation of exponential matrix functions which drastically reduces computational complexity by eliminating the need to perform computations enforcing constraints in exponential calculations while still preserving a high order of accuracy and allowing for a large time step even when the problem is stiff. This idea is similar to the W-methods and is achieved by carefully designing a method with the desired order of accuracy, even with an incomplete Jacobian matrix used as an argument of exponential-like functions. The constraints are accounted for by including them in the evaluation of the right-hand-side forcing function of the spatially discretized system. We study performance of the new methods on test problems and outline future research directions that this work opens.

70 PLASMA PHYSICS AND FUSION TECHNOLOGY↗

Parametric reduced order models for graded lattice structures

Graded lattice structures, characterized by smoothly varying mechanical properties, hold significant promise for optimizing material distribution in advanced engineering applications. However, accurately modeling these structures poses substantial computational challenges due to the continuous geometric variations within their unit cells. Here, to address these challenges, this paper introduces a novel Efficient Reduced Order Model (EROM) that integrates the Matrix Discrete Empirical Interpolation Method (MDEIM) and Discrete Empirical Interpolation Method (DEIM) with polynomial regression to efficiently manage geometric parametrization in lattice structures. Unlike traditional reduced order models (ROMs) that require extensive precomputed libraries for each geometric configuration, our approach enables continuous geometric variations through a flexible algebraic formulation, significantly reducing computational costs while preserving high accuracy. The method constructs projection matrices for individual unit cells that can be efficiently assembled into global systems, leveraging the repetitive nature of lattice structures. Numerical studies demonstrate that our EROM achieves displacement errors below 1% and von Mises stress prediction errors below 4%, coupled with computational speedups exceeding two orders of magnitude compared to full-order simulations. The proposed method's modularity and scalability make it particularly suitable for design optimization and real-time simulation of functionally graded lattice structures, with applications spanning aerospace to biomedical engineering.

11 - NUCLEAR FUEL CYCLE AND FUEL MATERIALS↗

A supernodal all-pairs shortest path algorithm

We show how to exploit graph sparsity in the Floyd-Warshall algorithm for the all-pairs shortest path (Apsp) problem. Floyd-Warshall is an attractive choice for Apsp on high-performing systems due to its structural similarity to solving dense linear systems and matrix multiplication. However, if sparsity of the input graph is not properly exploited, Floyd-Warshall will perform unnecessary asymptotic work and thus may not be a suitable choice for many input graphs. To overcome this limitation, the key idea in our approach is to use the known algebraic relationship between Floyd-Warshall and Gaussian elimination, and import several algorithmic techniques from sparse Cholesky factorization, namely, fill-in reducing ordering, symbolic analysis, supernodal traversal, and elimination tree parallelism. When combined, these techniques reduce computation, improve locality and enhance parallelism. We implement these ideas in an efficient shared memory parallel prototype that is orders of magnitude faster than an efficient multi-threaded baseline Floyd-Warshall that does not exploit sparsity. Our experiments suggest that the Floyd-Warshall algorithm can compete with Dijkstra's algorithm (the algorithmic core of Johnson's algorithm) for several classes sparse graphs.

Sao, Piyush↗

Hierarchical off-diagonal low-rank approximation of Hessians in inverse problems, with application to ice sheet model initialization

Obtaining lightweight and accurate approximations of discretized objective functional Hessians in inverse problems governed by partial differential equations (PDEs) is essential to make both deterministic and Bayesian statistical large-scale inverse problems computationally tractable. The cubic computational complexity of dense linear algebraic tasks, such as Cholesky factorization, that provide a means to sample Gaussian distributions and determine solutions of Newton linear systems is a computational bottleneck at large-scale. These tasks can be reduced to log-linear complexity by utilizing hierarchical off-diagonal low-rank (HODLR) matrix approximations. In this work, we show that a class of Hessians that arise from inverse problems governed by PDEs are well approximated by the HODLR matrix format. In particular, we study inverse problems governed by PDEs that model the instantaneous viscous flow of ice sheets. In these problems, we seek a spatially distributed basal sliding parameter field such that the flow predicted by the ice sheet model is consistent with ice sheet surface velocity observations. Here, we demonstrate the use of HODLR Hessian approximation to efficiently sample the Laplace approximation of the posterior distribution with covariance further approximated by HODLR matrix compression. Computational studies are performed which illustrate ice sheet problem regimes for which the Gauss–Newton data-misfit Hessian is more efficiently approximated by the HODLR matrix format than the low-rank (LR) format. We then demonstrate that HODLR approximations can be favorable, when compared to global LR approximations, for large-scale problems by studying the data-misfit Hessian associated with inverse problems governed by the first-order Stokes flow model on the Humboldt glacier and Greenland ice sheet.

97 MATHEMATICS AND COMPUTING↗

State-space solutions to standard H2 and H(infinity) control problems

Simple state-space formulas are derived for all controllers solving the standard H(infinity) problem of finding, for a given number gamma greater than 0, all controllers such that the H(infinity) norm of the closed-loop transfer function is (strictly) less than gamma. It is known that a controller exists if and only if the unique stabilizing solutions to two algebraic Riccati equations are positive definite and the spectral radius of their product is less than gamma squared. Under these conditions, a parameterization of all controllers solving the problem is given as a linear fractional transformation (LFT) on a contractive stable free parameter. The state dimension of the coefficient matrix for the LFT, constructed using the two Riccati solutions, equals that of the plant and has a separation structure reminiscent of classical LQG (i.e., H2) theory. A standard H2 solution is developed in parallel.

Doyle, John C.↗

Sensitivity analysis and approximation methods for general eigenvalue problems

Optimization of dynamic systems involving complex non-hermitian matrices is often computationally expensive. Major contributors to the computational expense are the sensitivity analysis and reanalysis of a modified design. The present work seeks to alleviate this computational burden by identifying efficient sensitivity analysis and approximate reanalysis methods. For the algebraic eigenvalue problem involving non-hermitian matrices, algorithms for sensitivity analysis and approximate reanalysis are classified, compared and evaluated for efficiency and accuracy. Proper eigenvector normalization is discussed. An improved method for calculating derivatives of eigenvectors is proposed based on a more rational normalization condition and taking advantage of matrix sparsity. Important numerical aspects of this method are also discussed. To alleviate the problem of reanalysis, various approximation methods for eigenvalues are proposed and evaluated. Linear and quadratic approximations are based directly on the Taylor series. Several approximation methods are developed based on the generalized Rayleigh quotient for the eigenvalue problem. Approximation methods based on trace theorem give high accuracy without needing any derivatives. Operation counts for the computation of the approximations are given. General recommendations are made for the selection of appropriate approximation technique as a function of the matrix size, number of design variables, number of eigenvalues of interest and the number of design points at which approximation is sought.

Murthy, D. V.↗

Unified formulation of dynamics for serial rigid multibody systems

There has been a growing interest in the development of new and efficient algorithms for multibody dynamics in recent years. Serial rigid multibody systems form the basic subcomponents of general multibody systems, and a variety of algorithms to solve the serial chain forward dynamics problem have been proposed. In this paper, the economy of representation and analysis tools provided by the spatial operator algebra are used to clarify the inherent structure of these algorithms, to identify those that are similar, and to study the relationships among the ones that are distinct. For the purposes of this study, the algorithms are categorized into three classes: algorithms that require the explicit computation of the mass matrix, algorithms that are completely recursive in nature, and algorithms of intermediate complexity. In addition, alternative factorizations for the mass matrix and closed form expressions for its inverse are derived. These results provide a unifying perspective, within which these diverse dynamics algorithms arise naturally as a consequence of a progressive exploitation of the structure of the mass matrix.

Jain, Abhinandan↗

More box codes

A new investigation shows that, starting from the BCH (21,15;3) code represented as a 7 x 3 matrix and adding a row and column to add even parity, one obtains an 8 x 4 matrix (32,15;8) code. An additional dimension is obtained by specifying odd parity on the rows and even parity on the columns, i.e., adjoining to the 8 x 4 matrix, the matrix, which is zero except for the fourth column (of all ones). Furthermore, any seven rows and three columns will form the BCH (21,15;3) code. This box code has the same weight structure as the quadratic residue and BCH codes of the same dimensions. Whether there exists an algebraic isomorphism to either code is as yet unknown.

Solomon, G.↗

Optimal Transfer Operators in Algebraic Two-Level Methods for Nonsymmetric and Indefinite Problems

Consider an algebraic two-level method applied to the 𝑛-dimensional linear system 𝐴⁢𝒙 = 𝒃 using fine-space preconditioner (i.e., “relaxation” or “smoother”) 𝑀, with 𝑀 ≈ 𝐴, restriction and interpolation 𝑅 and 𝑃, and algebraic coarse-space operator 𝐴 𝑐 : = 𝑅 ∗ ⁢𝐴⁢𝑃. Then, what are the best possible transfer operators 𝑅 and 𝑃 of a given dimension 𝑛 𝑐 < 𝑛? Brannick et al. [12] showed that when 𝐴 and 𝑀 are Hermitian positive definite (HPD), the optimal interpolation is such that its range contains the 𝑛 𝑐 smallest generalized eigenvectors of the matrix pencil (𝐴, 𝑀). Recently, in Ali et al. [5] we generalized this framework to the non-HPD setting, by considering both right (interpolation) and left (restriction) generalized eigenvectors of (𝐴, 𝑀) and defining corresponding nonsymmetric transfer operators {𝑅#, 𝑃#}. Tight convergence bounds for {𝑅#, 𝑃#} are derived in spectral radius, as well as a proof of pseudo-optimality. Note, {𝑅#, 𝑃#} are typically complex valued, which is not practical for real-valued problems. Here, in this work, we build on [5], first characterizing all inner products in which the coarse-space correction defined by {𝑅#, 𝑃#} is orthogonal. We then develop tight two-level convergence bounds in these norms, and prove that the underlying transfer operators {𝑅#, 𝑃#} are genuinely optimal. As a special case, our theory both recovers and extends the HPD results from [12]. Finally, we show how to construct optimal, real-valued transfer operators in the case of that 𝐴 and 𝑀 are real valued, but are not HPD. Numerical examples arising from a discretized advection-reaction equation, wave-equation, and Stokes equations are used to verify and illustrate the theory.

97 MATHEMATICS AND COMPUTING↗

A Fast Algebraic Multigrid Solver and Accurate Discretization for Highly Anisotropic Heat Flux I: Open Field Lines

We present a novel solver technique for the anisotropic heat flux equation, aimed at the high level of anisotropy seen in magnetic confinement fusion plasmas. Such problems pose two major challenges: (i) discretization accuracy and (ii) efficient implicit linear solvers. We simultaneously address each of these challenges by constructing a new finite element discretization with excellent accuracy properties, tailored to a novel solver approach based on algebraic multigrid (AMG) methods designed for advective operators. We pose the problem in a mixed formulation, introducing the directional temperature gradient as an auxiliary variable. The temperature and auxiliary fields are discretized in a scalar discontinuous Galerkin space with upwinding principles used for discretizations of advection. We demonstrate the proposed discretization’s superior accuracy over other discretizations of anisotropic heat flux, achieving error 1000x smaller for anisotropy ratio of 10 9 , for closed field lines. The block matrix system is reordered and solved in an approach where the two advection operators are inverted using AMG solvers based on approximate ideal restriction, which is particularly efficient for upwind discontinuous Galerkin discretizations of advection. To ensure that the advection operators are nonsingular, in this paper we restrict ourselves to considering open (acyclic) magnetic field lines for the linear solvers. We demonstrate fast convergence of the proposed iterative solver in highly anisotropic regimes where other diffusion-based AMG methods fail.

97 MATHEMATICS AND COMPUTING↗

The analysis of convolutional codes via the extended Smith algorithm

Convolutional codes have been the central part of most error-control systems in deep-space communication for many years. Almost all such applications, however, have used the restricted class of (n,1), also known as 'rate 1/n,' convolutional codes. The more general class of (n,k) convolutional codes contains many potentially useful codes, but their algebraic theory is difficult and has proved to be a stumbling block in the evolution of convolutional coding systems. In this article, the situation is improved by describing a set of practical algorithms for computing certain basic things about a convolutional code (among them the degree, the Forney indices, a minimal generator matrix, and a parity-check matrix), which are usually needed before a system using the code can be built. The approach is based on the classic Forney theory for convolutional codes, together with the extended Smith algorithm for polynomial matrices, which is introduced in this article.

Mceliece, R. J.↗

Scalable learning of potentials to predict time-dependent Hartree–Fock dynamics

We propose a framework to learn the time-dependent Hartree–Fock (TDHF) inter-electronic potential of a molecule from its electron density dynamics. Although the entire TDHF Hamiltonian, including the inter-electronic potential, can be computed from first principles, we use this problem as a testbed to develop strategies that can be applied to learn a priori unknown terms that arise in other methods/approaches to quantum dynamics, e.g., emerging problems such as learning exchange–correlation potentials for time-dependent density functional theory. We develop, train, and test three models of the TDHF inter-electronic potential, each parameterized by a four-index tensor of size up to 60 × 60 × 60 × 60. Two of the models preserve Hermitian symmetry, while one model preserves an eight-fold permutation symmetry that implies Hermitian symmetry. Across seven different molecular systems, we find that accounting for the deeper eight-fold symmetry leads to the best-performing model across three metrics: training efficiency, test set predictive power, and direct comparison of true and learned inter-electronic potentials. All three models, when trained on ensembles of field-free trajectories, generate accurate electron dynamics predictions even in a field-on regime that lies outside the training set. To enable our models to scale to large molecular systems, we derive expressions for Jacobian-vector products that enable iterative, matrix-free training.

97 MATHEMATICS AND COMPUTING↗

Topological field theory with Haagerup symmetry

Here, we construct a (1 + 1)d topological field theory (TFT) whose topological defect lines (TDLs) realize the transparent Haagerup $\mathscr{H}$ 3 fusion category. This TFT has six vacua, and each of the three non-invertible simple TDLs hosts three defect operators, giving rise to a total of 15 point-like operators. The TFT data, including the three-point coefficients and lasso diagrams, are determined by solving all the sphere four-point crossing equations and torus one-point modular invariance equations. We further verify that the Cardy states furnish a non-negative integer matrix representation under TDL fusion. While many of the constraints we derive are not limited to this particular TFT with six vacua, we leave open the construction of TFTs with two or four vacua. Finally, TFTs realizing the Haagerup $\mathscr{H}$ 1 and $\mathscr{H}$ 2 fusion categories can be obtained by gauging algebra objects. This article makes a modest offering in our pursuit of exotica and the quest for their eventual conformity.

97 MATHEMATICS AND COMPUTING↗

Elimination on sparse symmetric systems of a special structure.

Consideration of the problem of finding a permutation of rows and columns and an algorithm for solving ordered systems of linear algebraic equations with sparse matrices having a certain regular structure. Two approaches to the solution of this problem, in which the sparsity is used to some extent, are outlined. One of them is a very general approach where optimal (or nearly optimal) ordering is sought and the algorithm for solving the ordered system treats the matrix element by element to perform only necessary operations. The other approach involves the use of band matrices. After comparing these two approaches, a third approach is then suggested which involves the use of pipe matrices, and a means of ordering the rows and columns to obtain this type of matrix is presented. Examples of matrices reordered by the proposed procedure are cited.

Segethova, J.↗

Efficient Unitary Designs from Random Sums and Permutations

A unitary k-design is an ensemble of unitaries that matches the first k moments of the Haar measure. In this work, we provide two efficient constructions of k-designs on n-qubits using new random matrix theory techniques. Our first construction is based on exponentiating sums of random i.i.d. Hermitian matrices and uses O(k2n2)-many gates. In the spirit of central limit theorems, we show that this random sum approximates the Gaussian Unitary Ensemble (GUE). We then show that the product of just two exponentiated GUE matrices is already approximately Haar random. Our second construction is based on products of exponentiated sums of random permutations and uses Õ(k poly (n)) many gates. The k dependence is optimal (up to polylogarithmic factors) and is inherited from the efficiency of existing k-wise independent permutations. Furthermore, replacing random permutations with quantum-secure pseudorandom permutations (PRPs), we also obtain a pseudorandom unitary (PRU) ensemble that is secure under nonadaptive queries. A central feature of both proofs is a new connection between the polynomial method in quantum query complexity and the large-dimension (N) expansion in random matrix theory. In particular, the first construction uses the polynomial method to control high moments of certain random matrix ensembles without requiring delicate Weingarten calculations. In doing so, we define and solve a moment problem on the unit circle, asking whether a finite number of equally weighted points can reproduce a given set of moments. In our second construction, the key step is to exhibit an orthonormal basis for irreducible representations of the partition algebra that has a low-degree large-N expansion. This allows us to show that the distinguishing probability is a low-degree rational polynomial of the dimension N.

algebra↗

A Note on Multigrid Theory for Non-nested Grids and/or Quadrature

We provide a unified theory for multilevel and multigrid methods when the usual assumptions are not present. For example, we do not assume that the solution spaces or the grids are nested. Further, we do not assume that there is an algebraic relationship between the linear algebra problems on different levels. What we provide is a computationally useful theory for adaptively changing levels. Theory is provided for multilevel correction schemes, nested iteration schemes, and one way (i.e., coarse to fine grid with no correction iterations) schemes. We include examples showing the applicability of this theory: finite element examples using quadrature in the matrix assembly and finite volume examples with non-nested grids. Our theory applies directly to other discretizations as well.

Douglas, C. C.↗